SoTabPlaneDragger(3)

NAME
SoTabPlaneDragger - The SoTabPlaneDragger class is a dragger you can translate and scale within a plane.

SYNOPSIS

#include <Inventor/draggers/SoTabPlaneDragger.h>

Inherits SoDragger.

  Public Member Functions
virtual SoType getTypeId (void) const
virtual const SoNodekitCatalog * getNodekitCatalog (void) const
SoTabPlaneDragger (void)
void adjustScaleTabSize (void)

  Static Public Member Functions
static SoType getClassTypeId (void)
static const SoNodekitCatalog * getClassNodekitCatalog (void)
static void initClass (void)

  Public Attributes
SoSFVec3f translation
SoSFVec3f scaleFactor

  Protected Member Functions
virtual const SoFieldData * getFieldData (void) const
virtual ~SoTabPlaneDragger (void)
virtual void GLRender (SoGLRenderAction *action)
virtual SbBool setUpConnections (SbBool onoff, SbBool doitalways=FALSE)
virtual void setDefaultOnNonWritingFields (void)
void reallyAdjustScaleTabSize (SoGLRenderAction *action)
void getXYScreenLengths (SbVec2f &lengths, const SbMatrix &localtoscreen, const SbVec2s &winsize)
void dragStart (void)
void drag (void)
void dragFinish (void)

  Static Protected Member Functions
static const SoFieldData ** getFieldDataPtr (void)
static const SoNodekitCatalog ** getClassNodekitCatalogPtr (void)

  Protected Attributes
SoSFNode cornerScaleCoords
SoSFNode cornerScaleTab0
SoSFNode cornerScaleTab1
SoSFNode cornerScaleTab2
SoSFNode cornerScaleTab3
SoSFNode edgeScaleCoords
SoSFNode edgeScaleTab0
SoSFNode edgeScaleTab1
SoSFNode edgeScaleTab2
SoSFNode edgeScaleTab3
SoSFNode planeSwitch
SoSFNode scaleTabHints
SoSFNode scaleTabMaterial
SoSFNode scaleTabMaterialBinding
SoSFNode scaleTabNormal
SoSFNode scaleTabNormalBinding
SoSFNode scaleTabs
SoSFNode translator

  Additional Inherited Members

Detailed Description

The SoTabPlaneDragger class is a dragger you can translate and scale within a plane. Here's how the dragger looks with its default geometry in the inactive state:

 Screen Shot of Default Dragger

For translation, click anywhere inside the dragger's plane and move it about in 2D.

For non-uniform scaling operations, click and drag any of the 4 side tabs. For uniform scaling, click and drag any of the 4 corner tabs.

See also
    SoTabBoxDragger

Constructor & Destructor Documentation

  SoTabPlaneDragger::SoTabPlaneDragger (void)
Default constructor, sets up the dragger nodekit catalog with the interaction and feedback geometry.

Nodekit structure (new entries versus parent class marked with arrow prefix):

CLASS SoTabPlaneDragger
-->'this'
      'callbackList'
      'topSeparator'
         'motionMatrix'
         'geomSeparator'
-->         'planeSwitch'
-->            'translator'
-->            'scaleTabs'
-->               'scaleTabMaterial'
-->               'scaleTabHints'
-->               'scaleTabMaterialBinding'
-->               'scaleTabNormalBinding'
-->               'scaleTabNormal'
-->               'edgeScaleCoords'
-->               'edgeScaleTab0'
-->               'edgeScaleTab1'
-->               'edgeScaleTab2'
-->               'edgeScaleTab3'
-->               'cornerScaleCoords'
-->               'cornerScaleTab0'
-->               'cornerScaleTab1'
-->               'cornerScaleTab2'
-->               'cornerScaleTab3'

(See SoBaseKit::printDiagram() for information about the output formatting.)

Detailed information on catalog parts:

CLASS SoTabPlaneDragger
PVT   'this',  SoTabPlaneDragger  ---
      'callbackList',  SoNodeKitListPart [ SoCallback, SoEventCallback ]
PVT   'topSeparator',  SoSeparator  ---
PVT   'motionMatrix',  SoMatrixTransform  ---
PVT   'geomSeparator',  SoSeparator  ---
PVT   'planeSwitch',  SoSwitch  ---
      'translator',  SoSeparator  ---
PVT   'scaleTabs',  SoSeparator  ---
      'scaleTabMaterial',  SoMaterial  ---
      'scaleTabHints',  SoShapeHints  ---
PVT   'scaleTabMaterialBinding',  SoMaterialBinding  ---
PVT   'scaleTabNormalBinding',  SoNormalBinding  ---
PVT   'scaleTabNormal',  SoNormal  ---
PVT   'edgeScaleCoords',  SoCoordinate3  ---
PVT   'edgeScaleTab0',  SoIndexedFaceSet  ---
PVT   'edgeScaleTab1',  SoIndexedFaceSet  ---
PVT   'edgeScaleTab2',  SoIndexedFaceSet  ---
PVT   'edgeScaleTab3',  SoIndexedFaceSet  ---
PVT   'cornerScaleCoords',  SoCoordinate3  ---
PVT   'cornerScaleTab0',  SoIndexedFaceSet  ---
PVT   'cornerScaleTab1',  SoIndexedFaceSet  ---
PVT   'cornerScaleTab2',  SoIndexedFaceSet  ---
PVT   'cornerScaleTab3',  SoIndexedFaceSet  ---

(See SoBaseKit::printTable() for information about the output formatting.)

  SoTabPlaneDragger::~SoTabPlaneDragger (void) [protected], [virtual]
Protected destructor.

(Dragger classes are derived from SoBase, so they are reference counted and automatically destroyed when their reference count goes to 0.)

Member Function Documentation

  SoType SoTabPlaneDragger::getClassTypeId (void) [static]
This static method returns the SoType object associated with objects of this class.

  SoType SoTabPlaneDragger::getTypeId (void) const [virtual]
Returns the type identification of an object derived from a class inheriting SoBase. This is used for runtime type checking and 'downward' casting.

Reimplemented from SoDragger.

  const SoFieldData ** SoTabPlaneDragger::getFieldDataPtr (void) [static], [protected]
This API member is considered internal to the library, as it is not likely to be of interest to the application programmer.
 Returns the SoFieldData class which holds information about fields in this node.

  const SoFieldData * SoTabPlaneDragger::getFieldData (void) const [protected], [virtual]
Returns a pointer to the class-wide field data storage object for this instance. If no fields are present, returns NULL.

Reimplemented from SoDragger.

  const SoNodekitCatalog * SoTabPlaneDragger::getClassNodekitCatalog (void) [static]
Returns the nodekit catalog which defines the layout of this class' kit.

  const SoNodekitCatalog * SoTabPlaneDragger::getNodekitCatalog (void) const [virtual]
Returns the nodekit catalog which defines the layout of this class' kit.

Reimplemented from SoDragger.

  const SoNodekitCatalog ** SoTabPlaneDragger::getClassNodekitCatalogPtr (void) [static], [protected]
Returns the pointer to the pointer of the nodekit catalog for this class.

  void SoTabPlaneDragger::initClass (void) [static]
Initializes type system for this dragger class.

Application programmers should usually not have to invoke this method, see documentation of SoInteraction::init().

  void SoTabPlaneDragger::adjustScaleTabSize (void)
Signals the dragger to recalculate the size of its tabs. This method is not doing anything useful in Coin, since the tab sizes are recalculated every time the dragger is rendered, even though this method has not been called.

  void SoTabPlaneDragger::GLRender (SoGLRenderAction * action) [protected], [virtual]
Action method for the SoGLRenderAction.

This is called during rendering traversals. Nodes influencing the rendering state in any way or want to throw geometry primitives at OpenGL override this method.

Reimplemented from SoDragger.

  SbBool SoTabPlaneDragger::setUpConnections (SbBool onoff, SbBool doitalways = FALSE) [protected], [virtual]
Sets up all internal connections for instances of this class.

(This method will usually not be of interest to the application programmer, unless you want to extend the library with new custom nodekits or dragger classes. If so, see the SoBaseKit class documentation.)

Reimplemented from SoInteractionKit.

  void SoTabPlaneDragger::setDefaultOnNonWritingFields (void) [protected], [virtual]
(Be aware that this method is unlikely to be of interest to the application programmer who does not want to extend the library with new custom nodekits or draggers. If you indeed are writing extensions, see the information in the SoBaseKit class documentation.)

This is a virtual method, and the code in it should call SoField::setDefault() with argument TRUE on part fields that should not be written upon scene graph export operations.

This is typically done when:

1.  field value is NULL and part is NULL by default
2.  it is a leaf SoGroup or SoSeparator node with no children
3.  it is a leaf listpart with no children and an SoGroup or SoSeparator container
4.  it is a non-leaf part and it is of SoGroup type and all fields are at their default values
Subclasses should usually override this to do additional settings for new member fields. From the subclass, do remember to call 'upwards' to your superclass' setDefaultOnNonWritingFields() method.
Reimplemented from SoDragger.

  void SoTabPlaneDragger::reallyAdjustScaleTabSize (SoGLRenderAction * action) [protected]
Recalculates the size of the tabs, based on the current view volume, the current viewport, the current model matrix and the current scale factor. If action == NULL, a default size will be used.

  void SoTabPlaneDragger::getXYScreenLengths (SbVec2f & lengths, const SbMatrix & localtoscreen, const SbVec2s & winsize) [protected]
Not implemented.

  void SoTabPlaneDragger::dragStart (void) [protected]
This API member is considered internal to the library, as it is not likely to be of interest to the application programmer.
Called when dragger is selected (picked) by the user.

  void SoTabPlaneDragger::drag (void) [protected]
This API member is considered internal to the library, as it is not likely to be of interest to the application programmer.
Called when user drags the mouse after picking the dragger.

  void SoTabPlaneDragger::dragFinish (void) [protected]
This API member is considered internal to the library, as it is not likely to be of interest to the application programmer.
Called when mouse button is released after picking and interacting with the dragger.

Member Data Documentation

  SoSFVec3f SoTabPlaneDragger::translation
Continuously updated to contain the current translation from the dragger's local origo position.

  SoSFVec3f SoTabPlaneDragger::scaleFactor
Continuously updated to contain the current vector of scaling along the X, Y and Z axes. The Z component will always be 1.0.

Author
Generated automatically by Doxygen for Coin from the source code.